import java.util.concurrent.ConcurrentSkipListMap.Iter
import org.apache.tools.ant.Task

import org.json.JSONArray
import org.json.JSONObject
import org.json.JSONTokener
import org.apache.tools.ant.Task

def traverse(String name, JSONObject json)
{
   Integer maxsize = Integer.MIN_VALUE
   Integer minsize = Integer.MAX_VALUE

   Integer i = 0
   Iterator<String>iter = json.keys()
   while (iter.hasNext())
   {
      String key = iter.next()
      switch (json.get(key).class)
      {
         case org.json.JSONObject:
            JSONObject obj = json.get(key)
            traverse(name + "@" + key, obj)
            if (obj.length() > maxsize) maxsize = obj.length()
            if (obj.length() < minsize) minsize = obj.length()
            break
         case org.json.JSONArray:
            JSONArray ary = json.get(key)
            if (ary.length() > maxsize) maxsize = ary.length()
            if (ary.length() < minsize) minsize = ary.length()
            traverse(name + "@" + key, ary)
            break
         default:
            if (1 > maxsize) maxsize = 1
            if (1 < minsize) minsize = 1
            project.setProperty(name + "@" + key, json.get(key).toString())
            break
      }
      ++i
   }
   project.setProperty(name + "(type)", "map")
}

def traverse(String name, JSONArray json)
{
   int maxsize = Integer.MIN_VALUE
   int minsize = Integer.MAX_VALUE

   for (int i = 0; i < json.length(); i++)
   {
      switch (json.get(i).class)
      {
         case org.json.JSONObject:
            JSONObject obj = json.get(i)
            traverse(name + "@" + i, obj)
            if (obj.length() > maxsize) maxsize = obj.length()
            if (obj.length() < minsize) minsize = obj.length()
            break
         case org.json.JSONArray:
            JSONArray ary = json.get(i)
            traverse(name + "@" + i, ary)
            if (ary.length() > maxsize) maxsize = ary.length()
            if (ary.length() < minsize) minsize = ary.length()
            break
         default:
            if (1 > maxsize) maxsize = 1
            if (1 < minsize) minsize = 1
            project.setProperty(name + "@" +i, json.get(i).toString())
            break
      }
   }
   project.setProperty(name + "(size)", json.length().toString())
   project.setProperty(name + "(type)", "array")
}

def traverse(String name, String value)
{
   if (value != "")
   {
      if (value.trim()[0] == '{')
      { // MAP
         JSONObject map = new JSONObject(value)
         traverse(name, map)
         project.setProperty(name + "(type)", "map");
      }
      else
      { // ARRAY
         JSONArray ary = new JSONArray(value)
         traverse(name, ary)
         project.setProperty(name + "(type)", "array");
      }
   }
}

/***** PUBLIC METHODS *****/

def traverse()
{
   String name = attributes.get("name")
   String value = attributes.get("value")
      
   traverse(name, value)
}

def callmacrodef() throws IllegalArgumentException
{
   String name = attributes.get("name")
   String args = attributes.get("args")
   String pass = attributes.get("pass")
   String sign = attributes.get("sign")
   String tmp = attributes.get("tmp")
   
   HashMap<String, Boolean> signature = new HashMap<String, Boolean>()
   if (sign != "")
   {
      JSONObject json = new JSONObject(sign)
      Iterator<String>iter = json.keys()
      while (iter.hasNext())
      {
         String key = iter.next()
         signature.put(key, false)
      }
   }
   
   t = project.createTask(name)
   
   if (args != "")
   {
      JSONObject json = new JSONObject(args)
      
      Iterator<String>iter = json.keys()
      while (iter.hasNext())
      {
         String key = iter.next()
         signature.put(key, true)
         String value = json.get(key).toString()
         t.setDynamicAttribute(key, value)
      }
   }
   
   if (signature.size() > 0)
   {
      Boolean signatureValid = true
      String requiredArguments = ""
      signature.each { k, v ->
         signatureValid = signatureValid && v
         if (!v)
         {
            requiredArguments += (requiredArguments == "") ? k : ", " + k
         }
      }
      
      if (!signatureValid)
      {
         throw new IllegalArgumentException("ERROR: Missing required arguments: " + requiredArguments)
      }
   }
   
   if (pass != "")
   {
      t.setDynamicAttribute("pass", pass)
   }

   if (tmp != "")
   {
      t.setDynamicAttribute("tmp", tmp)
   }

   t.perform()
}
