// Copyright (c) 2002-2011, SAS Institute Inc., Cary, NC, USA, All Rights Reserved

package com.sas.config;

import java.io.File;

class PropertyContextBuilder extends ContextBuilder {
	private Context propertyContext = new Context()
	
	public void addProperty(String name, Object value) {
		propertyContext.setProperty(name, value)
	}
	
	public Object getProperty(String name) { return propertyContext.getProperty(name) }
				
	public void load(File propertiesFile) {
		Properties properties = new Properties()
		properties.load(new FileInputStream(propertiesFile))		
		for(String name : properties.keys()) {
			propertyContext.setProperty(name, properties.get(name))
		}
	}	
	
	protected Context buildInternal(File templateFile, Context context) {
		context.putAll(propertyContext)
		return context
	}
}
