// Copyright (c) 2002-2011, SAS Institute Inc., Cary, NC, USA, All Rights Reserved

package com.sas.config

public class Resource extends HashMap<String, Object> {
	
	public Resource() {}
	
	public Resource(File propertiesFile) {
		loadProperties(propertiesFile)
	}
	
	public Resource(Resource r) {
		// Copy r's properties to this object. (Shallow copy).
		r.keySet().each() { key ->
			this.setProperty(key, r.getProperty(key))
		}
	}	
	
	public void loadProperties(File propertiesFile) {
		// TODO: Encoding for docparts?
		Properties properties = new Properties()
		properties.load(new FileInputStream(propertiesFile))
		properties.keySet().each() { key ->
			setProperty(key, properties.get(key))
		}		
	}
	
	public void setProperty(String name, Object value) {
		if(value != "not-set") {
			this.put(name, value)
		}
	}
	
	public Object getProperty(String name) {
		return this.get(name)
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer()
		for(String key : this.keySet()) {
			sb.append("$key="+this.get(key)+"\n")
		}
		
		return sb.toString()
	}
}
