// Copyright (c) 2002-2011, SAS Institute Inc., Cary, NC, USA, All Rights Reserved

package com.sas.config.jboss
import com.sas.config.jboss.*

public class Ant{
    static final AntBuilder ant = new AntBuilder();

    static void copyDir(String SOURCE_DIR, String TARGET_DIR, String EXCLUDE,String OVERWRITE){
        ant.copy(todir:TARGET_DIR,overwrite:OVERWRITE){
            fileset(dir:SOURCE_DIR, excludes:EXCLUDE)
        }       
    }
    static void copyDir(String SOURCE_DIR, String TARGET_DIR, String OVERWRITE){
        ant.copy(todir:TARGET_DIR,overwrite:OVERWRITE){
            fileset(dir:SOURCE_DIR)
        }       
    }
    static void copyFile(String SOURCE, String TARGET, String OVERWRITE){
        ant.copy(file:SOURCE,tofile:TARGET,overwrite:OVERWRITE, failonerror:"true")
    }
    static void copyFile(String SOURCE, String TARGET, String OVERWRITE, String FAILONERROR){
        ant.copy(file:SOURCE,tofile:TARGET,overwrite:OVERWRITE, failonerror:FAILONERROR)
    }
    static void copyFileToDir(String SOURCE, String TARGET, String OVERWRITE){
        ant.copy(file:SOURCE,todir:TARGET,overwrite:OVERWRITE, failonerror:"true")
    }
    static void copyFileToDir(String SOURCE, String TARGET, String OVERWRITE, String FAILONERROR){
        ant.copy(file:SOURCE,todir:TARGET,overwrite:OVERWRITE, failonerror:FAILONERROR)
    }
    static void exec(String dir, String exe, String line){
        Logger.log('DEBUG', "ant.exec: ")
        Logger.log('DEBUG', "ant.exec: dir=$dir exe=$exe output=$dir\\exec.txt arg:line=$line")
        ant.exec(
           dir: dir,
           executable: exe,
           output: dir+"\\exec.txt"){
            arg(line: line)
           }
        def outputFile = new File(dir+"\\exec.txt")
        Logger.log('DEBUG',outputFile.text)
        //ant.delete(file:dir+"\\exec.txt", quiet:"true")
    }
    static void mkdir(String source){
    	ant.mkdir(dir:source)
    }
    static void touch(String source){
        ant.touch(file:source,mkdirs:"true")
    }
    static void touchDir(String source){
        ant.touch(mkdirs:"true"){
            dirset(dir:source)
        }       
    }
    static void deleteDir(String source){
    	ant.delete(dir:source,
    			   failonerror:"false")
    }
    static void deleteFile(String source){
    	ant.delete(file:source,
    			   failonerror:"false")
    }
    static void unzip(String source, String destination, String overwrite) {
    	ant.unzip(  src:source, 
                dest:destination, 
                overwrite:overwrite ) 

    }
}
