// Copyright (c) 2002-2011, SAS Institute Inc., Cary, NC, USA, All Rights Reserved

package com.sas.config.jboss.docparts


/* Create a list of property maps that share a property setting. */
class ResourceFinder {
    
    private HashMap context
	private ArrayList found
	
    public ResourceFinder(HashMap context) {
        this.context = context
        println "ResourceFinder context : " + this.context
    }
	
	public ArrayList getResources(String contextKey, String propName, String propValue) { 
		found = new ArrayList()
        Object temp = context[contextKey]
        List contextList = null
        
        if (temp instanceof List) {
            contextList = (List) temp
            for (int i = 0; i < contextList.size(); i++) {
                if (contextList[i][propName].equals(propValue))
                    found.add(contextList[i])
            }
        } else {
            println "ResourceFinder : " + context[contextKey] + " is not a List."
            return null
		}
        println "ResourceFinder found : " + found
		return found
    }
}

/* Create a property map of CustomPropertyTable input. */
class CustomProperties {
	
	private HashMap custProps 
	
	public CustomProperties() {
	    custProps = new HashMap();
	}
	
	ArrayList getCustomPropertyKeys(HashMap props) {
		custProps.clear()
		String propStr = null
		if ((propStr = props["CustomPropertyList"]) != null) {
		    ArrayList propArr = propStr.split(",")
			for (prop in propArr) {
				String name = null
				String value = null
				String propName = prop + "_name"
				String propValue = prop + "_value"
			    if ((name = props[propName]) != null &&
				    !name.equals("")) {
					if ((value = props[propValue]) != null &&
					    !value.equals("") ) {    
					    /* 
					       There should be no map entry if:
					       - the property name key isn't found
					       - the property value is null
					       - the property value equals "not-set"
					     */ 
					    if (!value.equals("not-set")) {
					        custProps[name] = value
					    }		        
					}
				} else {
				    continue
				}
			}
		} else {
		    println "CustomProperties : CustomPropertyList property not found."
		}
		Set keys = custProps.keySet()
		return new ArrayList(keys).sort()
	}
	
	String getCustomPropertyValue(String key) {
	    return custProps[key]
	}
}

/* Access Java System properties. */
class SystemProperties {
	
	public SystemProperties() {}
	
	String getSystemPropertyValue(String key) {
		return System.getProperty(key)
	}
}