// Copyright (c) 2002-2011, SAS Institute Inc., Cary, NC, USA, All Rights Reserved

package com.sas.config.weblogic

import com.sas.config.Resource

class Credentials extends WebLogicResource {
	public static final String NOT_SET = "not-set"
	
	public Credentials() {}
	public Credentials(Resource resource) { super(resource) }
	public Credentials(File resourceFile) { super(resourceFile) }
	
	@Override
	public String toString() {
		// Defect S0729295: Credentials should not be printed or logged.
		return "******** "
	}	
	
	@Override
	public void setProperty(String name, Object value) {
		if(value != NOT_SET) {
			this.put(replacePeriodsWithUnderscore(name), value)
		}
	}
	
	private String replacePeriodsWithUnderscore(String propertyName) {
		if(propertyName != null) {
			propertyName = propertyName.replaceAll('\\.', '_')
		}
		return propertyName
	}
}
