// Copyright (c) 2002-2011, SAS Institute Inc., Cary, NC, USA, All Rights Reserved

package com.sas.config.weblogic;

import java.io.File;
import java.util.List;
import java.util.Map;

class GlobalResource extends WebLogicResource {
	public static final String DOMAIN_CHANGES = "domainChanges"
	public static final String MACHINE_CHANGES = "machineChanges"
	
	public GlobalResource() {}
	public GlobalResource(File propertiesFile) {
		super(propertiesFile)
	}	
	
	public List<Map<String,String>> getDomainChanges() {
		return getAttributeChanges(DOMAIN_CHANGES)
	}
	
	public List<Map<String,String>> getMachineChanges() {
		return getAttributeChanges(MACHINE_CHANGES)
	}
	
	public boolean hasDomainChanges() {
		return (getDomainChanges().size() > 0)
	}
	
	public boolean hasMachineChanges() { 
		return (getMachineChanges().size() > 0)
	}
}
