// Copyright (c) 2002-2011, SAS Institute Inc., Cary, NC, USA, All Rights Reserved

package com.sas.config.weblogic;

import java.io.File;
import java.util.List;
import java.util.Map;

class ManagedServer extends WebLogicResource {
	public static final String CMD_LINE_CHANGES = "cmdLineChanges"
	public static final String CMD_LINE_SCRIPT_CHANGES = "cmdLineScriptChanges"
	public static final String SERVER_CHANGES = "serverChanges"	
		
	public ManagedServer() {}
	public ManagedServer(File propertiesFile) {
		super(propertiesFile)
	}
	
	public List<Map<String,String>> getCommandLineChanges() {
		return getCommandLineChanges(CMD_LINE_CHANGES)
	}
	
	public List<Map<String,String>> getCommandLineScriptChanges() {
		return getCommandLineChanges(CMD_LINE_SCRIPT_CHANGES)
	}	
	
	public List<Map<String,String>> getAttributeChanges() {
		return getAttributeChanges(SERVER_CHANGES)
	}	
	
	public boolean hasChanges() {
		return hasCommandLineChanges() ||  hasCommandLineScriptChanges()  || hasAttributeChanges() 
	}
	
	public boolean hasCommandLineChanges() {
		return (getCommandLineChanges().size() > 0) 
	}
	
	public boolean hasCommandLineScriptChanges() {
		return (getCommandLineScriptChanges().size() > 0)
	}
	
	public boolean hasAttributeChanges() {
		return (getAttributeChanges().size() > 0)
	}	
}
