// Copyright (c) 2002-2011, SAS Institute Inc., Cary, NC, USA, All Rights Reserved

package com.sas.config.weblogic

import com.sas.config.util.PropertyUtils
import com.sas.config.DirectoryResourceLoader
import java.util.Properties
import java.util.regex.Pattern

class SortResourceProperties  extends GroovyScriptInvoker {
	List<File> files;
	
	public static void main(String[] args) {
		SortResourceProperties rp = new SortResourceProperties(args[0], args[1]);
		rp.sort();
	}

	public SortResourceProperties(domainPropertiesFileName, resourcePropertiesFileName) {
		super(domainPropertiesFileName, resourcePropertiesFileName);
		File resourceFile = new File(domainPropertiesFileName)
		File propsDirectory = resourceFile.getParentFile();
		DirectoryResourceLoader resourceLoader = new DirectoryResourceLoader();
		resourceLoader.setDirectory(propsDirectory)
		resourceLoader.setFilenamePattern(~/\.properties/)
		files = resourceLoader.getFiles()
	}
	
	public sort() {
		files.each { it ->
			Properties p = PropertyUtils.loadProperties(it)
			PropertyUtils.writeProps(p, it)
		}
		writeRC("RC_OK");
	}
}
