import java.rmi.RemoteException;
import java.util.Iterator;
import java.util.List;

import com.sas.metadata.remote.CMetadata;
import com.sas.metadata.remote.Machine;
import com.sas.metadata.remote.MdException;
import com.sas.metadata.remote.MdFactory;
import com.sas.metadata.remote.MdFactoryImpl;
import com.sas.metadata.remote.MdOMIUtil;
import com.sas.metadata.remote.MdObjectStore;
import com.sas.metadata.remote.ServerComponent;
import com.sas.metadata.remote.TCPIPConnection;
import com.sas.metadata.remote.Tree;

import com.sas.scheduler.api.oma.MetaUtilities; 
import com.sas.scheduler.api.servers.lsf.LSFScheduler;

rc = 0;
rcPropName = attributes.get("resultsproperty");
ant = new AntBuilder();

try
  {
  //-----------------------------------------------------------------
  // Get properties from Ant
  //-----------------------------------------------------------------
  def _metaMachine  = project.getProperty("iomsrv.metadatasrv.host");
  def _metaPort     = project.getProperty("iomsrv.metadatasrv.port");
  def _metaUser     = project.getProperty("oma.person.admin.login.userid");
  def _metaPassword = project.getProperty("oma.person.admin.login.passwd");
  def _FQID         = project.getProperty("platformpm.configobj.fqid");
  def _host         = project.getProperty("server.platformpm.host");
  def _port         = project.getProperty("server.platformpm.port");
  def _user         = project.getProperty("oma.person.admin.login.userid");
  def _password     = project.getProperty("oma.person.admin.login.passwd");

  if (_FQID == null)
    {
    rc = 1;
    project.setNewProperty(rcPropName, "" + rc);
    return;
    }
  
  //-----------------------------------------------------------------
  // Set java.security.auth.login.config property
  //-----------------------------------------------------------------
  File tempfile = File.createTempFile("login", "config");
  tempfile.deleteOnExit();
  FileOutputStream out = new FileOutputStream(tempfile);
  StringBuffer buffer = new StringBuffer();
  buffer.append("UsernamePassword {");
  buffer.append("  com.platform.SASLogin.UsernamePasswordLogin required ;");
  buffer.append("};");
  out.write(buffer.toString().getBytes());
  out.flush();
  out.close();
  System.setProperty("java.security.auth.login.config", tempfile.getAbsolutePath());

  //-----------------------------------------------------------------
  // Make a JOMA connection.
  //-----------------------------------------------------------------
  MdFactory factory = new MdFactoryImpl();
  factory.makeOMRConnection(_metaMachine, _metaPort, _metaUser, _metaPassword);
  String repos = "A0000001." + _FQID.substring(0,MetaUtilities.SHORT_REPOSITORY_ID_SIZE); 
  MdObjectStore store = factory.createObjectStore();

  // get the scheduler and validate its metadata against the server daemon
  ServerComponent sc = (ServerComponent) MetaUtilities.getSchedulerServer(_FQID, store, repos);

  // fix the host and port
  boolean update   = false;
  List connections = sc.getSourceConnections();
  if (connections != null && connections.size() > 0)
    {
    TCPIPConnection connection = (TCPIPConnection) connections.get(0);
    if (connection != null)
      {
      String old_host = connection.getHostName();
      if (old_host.compareTo(_host) != 0)
        {
        self.log("Info: fixing the host for TCPIP connection");
        connection.setHostName(_host);
        update = true;

        // see if the old machine is in the name too
        String name = connection.getName();  
        if (name.contains(old_host))
          {
          self.log("Info: fixing the name for TCPIP connection");
          String newName = MetaUtilities.replaceString(name, old_host, _host);
          connection.setName(newName);
          }
        name = sc.getName();
        if (name.contains(old_host))
          {
          self.log("Info: fixing the name for ServerComponent");
          String newName = MetaUtilities.replaceString(name, old_host, _host);
          sc.setName(newName);
          }
        }
      int port    = connection.getPort();
      int neoport = Integer.valueOf(_port).intValue();
      if (port != neoport)
        {
        self.log("Info: fixing the port for TCPIP connection");
        connection.setPort(neoport);
        update = true;
        }
      }
    }
   
  if (update)
    {
    self.log("Info: updating metadata for ServerComponent " + sc.getFQID());
    self.log("Info:   ServerComponent name is " + sc.getName());
    store.updatedMetadataAll();
    }
  
  //-----------------------------------------------------------------
  // fix anything else that does not match
  //-----------------------------------------------------------------
  self.log("Info: checking metadata against the installation");
  if (!LSFScheduler.validateVersion(sc, _user, _password))
    {
    rc = 2;
    }

  //-----------------------------------------------------------------
  // Clean up
  //-----------------------------------------------------------------
  store.dispose();
  factory.dispose();
  }
catch (Exception e)
  {
  sw = new StringWriter();
  pw = new PrintWriter(sw);
  e.printStackTrace(pw);
  ant.echo(level:"info", message:sw.toString());
  rc = 3;
  }

//-----------------------------------------------------------------
// Set the return code
//-----------------------------------------------------------------
self.log("rc is " + rc); 
project.setNewProperty(rcPropName, "" + rc);
