@rem *************************************************************************
@rem This script is used to initialize common environment to start WebLogic
@rem Server, as well as WebLogic development.  This is a wrapper for the
@rem installed version of commEnv.cmd that is needed for use with the SAS 
@rem automatically configured environment.
@rem 
@rem SAS provides custom versions of all BEA scripts that are used for SAS 
@rem configuration. In this way, the SAS installers don't have to modify your BEA 
@rem Weblogic installation.

set JAVA_VENDOR=${global.javaVendor}
set JAVA_HOME=${global.javaHome}
FOR %%i IN ("%JAVA_HOME%") DO SET JAVA_HOME=%%~fsi
set PRODUCTION_MODE=true
set JAVA_OPTIONS=%JAVA_OPTIONS% ${global.jdkBugWorkaround} ${global.midtierMulticastIpJavaOptions}
set ANT_OPTS=${global.jdkBugWorkaround} 

call "%WL_HOME%\common\bin\commEnv.cmd"

set WEBLOGIC_CLASSPATH=%WEBLOGIC_CLASSPATH%

@rem *********** Web Authentication Configuration *****************************
@rem If you are configuring your domain to use WebLogic Embedded LDAP Authentication as your
@rem authentication provider, copy the authentication provider jars into the webauth directory under
@rem your current domain and uncomment the following three lines. 
${global.webauthIsComment} set WEBAUTH=${global.domainDir}\webauth
${global.webauthIsComment} set WEBAUTH_CLASSPATH=%WEBAUTH%\sas.core.jar;%WEBAUTH%\sas.core.nls.jar;%WEBAUTH%\sas.oma.omi.jar;%WEBAUTH%\sas.security.sspi.jar;%WEBAUTH%\sas.svc.connection.jar;%WEBAUTH%\sas.svc.connection.nls.jar;%WEBAUTH%\sas.svc.sec.login.jar;%WEBAUTH%\sas.svc.sec.login.nls.jar;%WEBAUTH%\sas.svc.sec.login.weblogic.jar;%WEBAUTH%\sas.svc.sec.login.weblogic.mbean.jar;%WEBAUTH%\sas.svc.sec.login.weblogic.mbean.nls.jar;%WEBAUTH%\sas.svc.sec.login.weblogic.nls.jar;%WEBAUTH%\sas.svcs.security.weblogic.jar;%WEBAUTH%\log4j.jar
${global.webauthIsComment} set WEBLOGIC_CLASSPATH=%WEBAUTH_CLASSPATH%;%WEBLOGIC_CLASSPATH%
